/**
 * \file
 *
 * \brief DALI]u󂯎鏈
 *
 * 쌠 (c) 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include "dali_top.h"
#include "dali_hal.h"
#include "dali_frame.h"
#include "dali_cmd.h"

#define W200MS		(0.2 * DALI_PWM_CLOCK_HZ)
#define W500MS		(0.5 * DALI_PWM_CLOCK_HZ)
#define W600MS		(0.6 * DALI_PWM_CLOCK_HZ)
#define W15MIN		(15 * 60 * DALI_PWM_CLOCK_HZ)

#define FAIL_TIME	W500MS
/* dٗp */
#define POWER_OFF	0x00
#define POWER_MASK	0xFF
#define POWER_MIN	0x01
#define POWER_MAX	0xFE

#define ADDR_MASK	0xFF

#define LOGARITHMIC	0x00
#define LINEAR		0x01

/* int_fade_directionp̒l */
enum {FADE_IDLE, FADE_STOP, FADE_TIME_UP, FADE_TIME_DOWN, FADE_TIME_DOWN_OFF,
      FADE_RATE_UP, FADE_RATE_DOWN, FADE_DIRECT};

bool write_memory_enabled = false;
/*  ݸ0؊蓖 */
#define BANK0						0x00
#define BANK0_LAST_MEMORY_LOCATION	0x0E
#define CHECKSUM_OF_BANK0			0x08
#define NUMBER_OF_LAST_BANK			0x01
#define GTIN0						0xFF
#define GTIN1						0xFF
#define GTIN2						0xFF
#define GTIN3						0xFF
#define GTIN4						0xFF
#define GTIN5						0xFF
#define FIRMWARE_MAJOR_VER			0x00
#define FIRMWARE_MINOR_VER			0x01
#define SERIAL_BYTE1				0xFF
#define SERIAL_BYTE2				0xFF
#define SERIAL_BYTE3				0xFF
#define SERIAL_BYTE4				0xFF

/*  ݸ1؊蓖 */
#define BANK1						0x01
#define NOT_LOCK					0x55

#define BANK1_LAST_MEMORY_LOCATION	0x0F
#define CHECKSUM_OF_BANK1			0x0E
#define BANK1_LOCK_BYTE				0xFF
#define OEM_GTIN0					0xFF
#define OEM_GTIN1					0xFF
#define OEM_GTIN2					0xFF
#define OEM_GTIN3					0xFF
#define OEM_GTIN4					0xFF
#define OEM_GTIN5					0xFF
#define OEM_SERIAL_BYTE1			0xFF
#define OEM_SERIAL_BYTE2			0xFF
#define OEM_SERIAL_BYTE3			0xFF
#define OEM_SERIAL_BYTE4			0xFF
#define SUBSYSTEM_DEVICE_NUM		0xFF
#define LAMP_TYPE_NUM				0xFF
#define LAMP_TPYE_NUM2				0xFF

struct uint24 search_address;

union variable_union dali_variable;
union bank_union dali_memory;

/* eeprom_featuresޯĒ` */
#define SHORT_CIRCUIT_CAN_BE_QUERIED		BIT0
#define OPEN_CIRCUIT_CAN_BE_QUERIED			BIT1
#define LOAD_DECREASE_CAN_BE_QUERIED		BIT2
#define LOAD_INCREASE_CAN_BE_QUERIED		BIT3
#define CURRENT_PROTECTOR_CAN_BE_QUERIED	BIT4
#define THERMAL_SHUT_DOWN_CAN_BE_QUERIED	BIT5
#define LIGHT_LEVEL_REDUCTION				BIT6
#define PHYSICAL_SELECTION_SUPPORTED		BIT7

/* `Ԃޯ4̒` */
#define NON_LOGARITHMIC_DIMMING_CURVE_ACTIVE	BIT4

/* ωɎgp - eINTɑ΂dali.long_levelɒǉiK
 * (flash_inv_fadetime_val)~(DALIł̕ύXl)Ɠ */
uint32_t fade_step;

/* "0"ɑ΂Č邽߁Â̂ŕt̕\L@gp */
volatile uint8_t fade_time;

volatile uint32_t w15min_waiting_time = 0;
/* 荞݂Ŏgp */
volatile uint32_t int_fade_step;

volatile bool interface_fail_flag = false;
volatile uint16_t interface_fail_time = 0;

volatile uint8_t fade_direction = FADE_IDLE;
/* DALI`Ԑݒ薽߂ɂĎgpް]ڼ޽ */
uint8_t dtr = 0x00;
uint8_t dtr1 = 0x00;
uint8_t dtr2 = 0x00;

bool physical_selection_mode = false;
bool physical_is_selected = false;
volatile uint16_t power_on_time = W600MS;
volatile bool power_on_flag = true;
/* 260`261ɂĎgp */
uint8_t withdraw;
uint8_t optional_features;

bool device_enabled = false;
volatile bool dapc_sequence = false;
volatile uint8_t dapc_sequence_time;
volatile bool need_fade = false;
volatile uint8_t status_information = 0x00;
#define STATUS_OF_CONTROL_GEAR	BIT0
#define LAMP_FAILURE			BIT1
#define LAMP_ARC_POWER_ON		BIT2
#define LIMIT_ERROR				BIT3
#define FADE_RUNNING			BIT4
#define RESET_STATE				BIT5
#define MISSING_SHORT_ADDR		BIT6
#define POWER_FAILURE			BIT7

uint8_t operation_mode = 0;

/* dali.leveldali.long_level͓lŁA1ւ݂̏͑XV܂B */
union daliunion {
	/* dali.long_level͒ωɎgpAŒDALIيԂ̊炩Ȓ
	 * ܂B */
	uint32_t long_level;
	struct {
		/* Lower 8 */
		uint8_t byte0;
		uint8_t byte1;
		uint8_t byte2;
		/* 8ޯĂdali.level͎ۂDALIقŁAXEEPROMɊi[܂B
		 * c͏lłB */
		uint8_t level;
	};
}
dali;
/* 荞݂Ŏgp */
volatile union int_daliunion {
	volatile uint32_t long_level;
	struct {
		volatile uint8_t byte0;
		volatile uint8_t byte1;
		volatile uint8_t byte2;
		volatile uint8_t level;
	};
}
int_dali;

/* ǉLEDPʕ` */
#define DEVICE_TYPE						LED_MODULES
#define EXTENDED_VER_NUM				1
#define MAX_FAST_FADE_TIME 				27

uint8_t fast_fade_time;
uint8_t failure_status = 0;
#define SHORT_CIRCUIT					BIT0
#define OPEN_CIRCUIT					BIT1
#define LOAD_DECREASE					BIT2
#define LOAD_INCREASE					BIT3
#define CURRENT_PROTECTOR_ACTIVE		BIT4
#define THERMAL_SHUT_DOWN				BIT5
#define THREMAL_OVERLOAD				BIT6
#define REFERRENCE_MEASUREMENT_FAILED	BIT7

/* DALIKiɏ]ČvZꂽ12ޯPWMlB4ޯĂ޲ē2l߂{#1#0, 
 * #3#2,`,#255#254}AׯԂߖ񂷂邽߂EEPORMްi[܂B */
uint8_t const flash_high_pwm_val[]
	= {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	   0x00, 0x00, 0x00, 0x00, 0x10, 0x11, 0x11, 0x11,
	   0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11,
	   0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22,
	   0x32, 0x33, 0x33, 0x33, 0x33, 0x33, 0x44, 0x44,
	   0x44, 0x44, 0x55, 0x55, 0x55, 0x65, 0x66, 0x66,
	   0x77, 0x77, 0x87, 0x88, 0x98, 0x99, 0xA9, 0xAA,
	   0xBA, 0xBB, 0xCC, 0xDC, 0xDD, 0xEE, 0xFF, 0xFF};

uint8_t const flash_low_pwm_val[]
	=  {0x00, 0x04, 0x04, 0x04, 0x04, 0x05, 0x05, 0x05,
		0x05, 0x05, 0x05, 0x05, 0x06, 0x06, 0x06, 0x06,
	    0x06, 0x06, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
	    0x08, 0x08, 0x08, 0x08, 0x09, 0x09, 0x09, 0x09,
	    0x0A, 0x0A, 0x0A, 0x0A, 0x0B, 0x0B, 0x0B, 0x0C,
	    0x0C, 0x0C, 0x0D, 0x0D, 0x0D, 0x0E, 0x0E, 0x0E,
	    0x0F, 0x0F, 0x10, 0x10, 0x10, 0x11, 0x11, 0x12,
	    0x12, 0x13, 0x13, 0x14, 0x15, 0x15, 0x16, 0x16,
	    0x17, 0x18, 0x18, 0x19, 0x1A, 0x1A, 0x1B, 0x1C,
	    0x1C, 0x1D, 0x1E, 0x1F, 0x20, 0x21, 0x22, 0x22,
	    0x23, 0x24, 0x25, 0x26, 0x27, 0x29, 0x2A, 0x2B,
	    0x2C, 0x2D, 0x2F, 0x30, 0x31, 0x32, 0x34, 0x35,
	    0x37, 0x38, 0x3A, 0x3B, 0x3D, 0x3F, 0x41, 0x42,
	    0x44, 0x46, 0x48, 0x4A, 0x4C, 0x4E, 0x50, 0x53,
	    0x55, 0x57, 0x5A, 0x5C, 0x5F, 0x61, 0x64, 0x67,
	    0x6A, 0x6C, 0x6F, 0x73, 0x76, 0x79, 0x7C, 0x80,
	    0x83, 0x87, 0x8B, 0x8E, 0x92, 0x96, 0x9B, 0x9F,
	    0xA3, 0xA8, 0xAC, 0xB1, 0xB6, 0xBB, 0xC0, 0xC6,
	    0xCB, 0xD1, 0xD7, 0xDD, 0xE3, 0xE9, 0xEF, 0xF6,
	    0xFD, 0x04, 0x0B, 0x12, 0x1A, 0x22, 0x2A, 0x32,
	    0x3B, 0x43, 0x4C, 0x55, 0x5F, 0x69, 0x72, 0x7D,
	    0x87, 0x92, 0x9D, 0xA9, 0xB4, 0xC1, 0xCD, 0xDA,
	    0xE7, 0xF4, 0x02, 0x10, 0x1F, 0x2E, 0x3D, 0x4D,
	    0x5E, 0x6E, 0x80, 0x91, 0xA4, 0xB6, 0xC9, 0xDD,
	    0xF1, 0x06, 0x1C, 0x32, 0x48, 0x60, 0x78, 0x90,
	    0xA9, 0xC3, 0xDE, 0xF9, 0x16, 0x33, 0x50, 0x6F,
	    0x8E, 0xAF, 0xD0, 0xF2, 0x15, 0x39, 0x5E, 0x84,
	    0xAB, 0xD3, 0xFC, 0x27, 0x52, 0x7F, 0xAD, 0xDD,
	    0x0D, 0x3F, 0x73, 0xA7, 0xDE, 0x15, 0x4F, 0x89,
	    0xC6, 0x04, 0x44, 0x86, 0xC9, 0x0E, 0x56, 0x9F,
	    0xEA, 0x37, 0x87, 0xD9, 0x2D, 0x83, 0xDB, 0x37,
	    0x94, 0xF4, 0x57, 0xBD, 0x25, 0x91, 0xFF, 0xFF};

/*
 * \̍ŏ̗vf0łAۂɂ͂ꂪ"ωȂ"Ӗ""
 * ׂłBgpAް͍ŏ޲ĂۂDALIlƉ24ޯĂ
 * 32ޯĒl"dali.long_level"ɐݒ肳܂BAωx(ړ)
 * ̂܂܎gpAtωԂ"iK̕ω"ŁAωDALIiK
 * ɂďZȂ΂Ȃ܂B
 */
/* ωxް͕\17ޯďɈړA"dali.long_level"ɐݒ肳
 * 7ޯĈȏړĂ邱ƂӖ܂B */
uint16_t const flash_fade_rate_val[]
	= {0x0000, 0xBB97, 0x84A5, 0x5DCB, 0x4253, 0x2EE6, 0x2129, 0x1773,
	   0x1095, 0x0BB9, 0x084A, 0x05DD, 0x0425, 0x02EE, 0x0213, 0x0177};
	   
/* tωް25ޯďړA͒iKł̕ύXŏŽA
 * "dali.long_level"ɐݒ肳鎞1ޯĉړ邱ƂӖ܂B */
uint16_t const flash_inv_fadetime_val[]
	= {0x0000, 0xBDD7, 0x8637, 0x5EEB, 0x431B, 0x2F75, 0x218D, 0x17B9,
	   0x10C6, 0x0BDC, 0x0863, 0x05EE, 0x0431, 0x02F7, 0x0218, 0x017B};

bool dali_cmd_check_reset_state(void);
uint16_t dali_cmd_read_pwm_value(uint8_t dali_value);
void dali_cmd_set_pwm_output(uint8_t dali_value);
uint16_t dali_cmd_process_common(dali_slave_service_info_t *slave_info,
		uint8_t repeat_flag);
uint16_t dali_cmd_process_extended_application(dali_slave_service_info_t *slave_info,
		uint8_t repeat_flag);
		
		
void dali_cmd_init(void)
{
	uint8_t	i;

	if(dali_hal_read_check_data(0, &(dali_variable.var.eeprom_target_level),
			sizeof(dali_variable.var)-1) != STATUS_OK)
	{
		/* l */
		dali_variable.var.eeprom_target_level = POWER_MAX;
		dali_variable.var.eeprom_power_on_level = POWER_MAX;
		dali_variable.var.eeprom_system_failure_level = POWER_MAX;
		dali_variable.var.eeprom_minimum_level = POWER_MIN;
		dali_variable.var.eeprom_maximum_level = POWER_MAX;
		dali_variable.var.eeprom_fade_rate = 0x07;
		dali_variable.var.eeprom_fade_time = 0x05;
		dali_variable.var.eeprom_short_address = ADDR_MASK;
		dali_variable.var.eeprom_group_0_7 = 0x00;
		dali_variable.var.eeprom_group_8_15 = 0x00;
		dali_variable.var.eeprom_version_number = 0x01;
		dali_variable.var.eeprom_physical_minimum_level = POWER_MIN;
		dali_variable.var.eeprom_min_fast_fade_time = 0x01;
		dali_variable.var.eeprom_fast_fade_time = 0x00;
		dali_variable.var.eeprom_gear_type = 0x00;
		dali_variable.var.eeprom_possible_operation_modes = 0x00;
		dali_variable.var.eeprom_features = 0xFF;
		dali_variable.var.eeprom_failure_status_operation_mode = REFERRENCE_MEASUREMENT_FAILED;
		dali_variable.var.eeprom_dimming_curve = LOGARITHMIC;
		dali_variable.var.eeprom_random_address.high = 0xFF;
		dali_variable.var.eeprom_random_address.mid = 0xFF;
		dali_variable.var.eeprom_random_address.low = 0xFF;
		for (i = 0; i < 16; i++) {
			dali_variable.var.eeprom_scene[i] = POWER_MASK;
		}
	}
	
	if(dali_hal_read_check_data(1, dali_memory.bank.eeprom_memory_bank0,
			sizeof(dali_memory.bank)-1) != STATUS_OK)
	{
		/* lAi ݸ0 */
		dali_memory.bank.eeprom_memory_bank0[0] = BANK0_LAST_MEMORY_LOCATION;
		dali_memory.bank.eeprom_memory_bank0[1] = CHECKSUM_OF_BANK0;
		dali_memory.bank.eeprom_memory_bank0[2] = NUMBER_OF_LAST_BANK;
		dali_memory.bank.eeprom_memory_bank0[3] = GTIN0;
		dali_memory.bank.eeprom_memory_bank0[4] = GTIN1;
		dali_memory.bank.eeprom_memory_bank0[5] = GTIN2;
		dali_memory.bank.eeprom_memory_bank0[6] = GTIN3;
		dali_memory.bank.eeprom_memory_bank0[7] = GTIN4;
		dali_memory.bank.eeprom_memory_bank0[8] = GTIN5;
		dali_memory.bank.eeprom_memory_bank0[9] = FIRMWARE_MAJOR_VER;
		dali_memory.bank.eeprom_memory_bank0[10] = FIRMWARE_MINOR_VER;
		dali_memory.bank.eeprom_memory_bank0[11] = SERIAL_BYTE1;
		dali_memory.bank.eeprom_memory_bank0[12] = SERIAL_BYTE2;
		dali_memory.bank.eeprom_memory_bank0[13] = SERIAL_BYTE3;
		dali_memory.bank.eeprom_memory_bank0[14] = SERIAL_BYTE4;
		
		/* i ݸ1 */
		dali_memory.bank.eeprom_memory_bank1[0] = BANK1_LAST_MEMORY_LOCATION;
		dali_memory.bank.eeprom_memory_bank1[1] = CHECKSUM_OF_BANK1;
		dali_memory.bank.eeprom_memory_bank1[2] = BANK1_LOCK_BYTE;
		dali_memory.bank.eeprom_memory_bank1[3] = OEM_GTIN0;
		dali_memory.bank.eeprom_memory_bank1[4] = OEM_GTIN1;
		dali_memory.bank.eeprom_memory_bank1[5] = OEM_GTIN2;
		dali_memory.bank.eeprom_memory_bank1[6] = OEM_GTIN3;
		dali_memory.bank.eeprom_memory_bank1[7] = OEM_GTIN4;
		dali_memory.bank.eeprom_memory_bank1[8] = OEM_GTIN5;
		dali_memory.bank.eeprom_memory_bank1[9] = OEM_SERIAL_BYTE1;
		dali_memory.bank.eeprom_memory_bank1[10] = OEM_SERIAL_BYTE2;
		dali_memory.bank.eeprom_memory_bank1[11] = OEM_SERIAL_BYTE3;
		dali_memory.bank.eeprom_memory_bank1[12] = OEM_SERIAL_BYTE4;
		dali_memory.bank.eeprom_memory_bank1[13] = SUBSYSTEM_DEVICE_NUM;
		dali_memory.bank.eeprom_memory_bank1[14] = LAMP_TYPE_NUM;
		dali_memory.bank.eeprom_memory_bank1[15] = LAMP_TPYE_NUM2;
	}
	
	if (dali_variable.var.eeprom_short_address == ADDR_MASK) {
		status_information |= MISSING_SHORT_ADDR;
	} else {
		status_information &= ~MISSING_SHORT_ADDR;
	}

	status_information |= POWER_FAILURE;
	optional_features = dali_variable.var.eeprom_features;

	fast_fade_time = dali_variable.var.eeprom_fast_fade_time;
	/* ؂ޯĂXV */
	failure_status
		|= dali_variable.var.eeprom_failure_status_operation_mode
			& REFERRENCE_MEASUREMENT_FAILED;
	operation_mode
		= dali_variable.var.eeprom_failure_status_operation_mode
			& NON_LOGARITHMIC_DIMMING_CURVE_ACTIVE;
}

void dali_cmd_direct_arc_power_control(uint8_t level)
{
	uint8_t level_change, current_fade;
	uint32_t step = 0;

	dali_hal_disable_fading_interrupt();
	dali.long_level = int_dali.long_level;

	device_enabled = false;
	write_memory_enabled = false;
	if (level == POWER_MASK) {
		/* ω~ӖՕ */
		fade_direction = FADE_STOP;
	} else {
		power_on_flag = false;
		status_information &= ~(LIMIT_ERROR + POWER_FAILURE);
		if (level == 0) {
			/* ŏقւ̏Ɩ~ωOFF؂ւ */
			fade_direction = FADE_TIME_DOWN_OFF;
			level_change = (dali.level -
					dali_variable.var.eeprom_minimum_level);
		} else {
			if (level < dali_variable.var.eeprom_minimum_level) {
				level = dali_variable.var.eeprom_minimum_level;
				eeprom_flag |= PAGE0_UPDATE;
				status_information |= LIMIT_ERROR;
			} else if (level >
					dali_variable.var.eeprom_maximum_level)
			{
				level = dali_variable.var.eeprom_maximum_level;
				status_information |= LIMIT_ERROR;
			}

			/* EEPROMlł͂ȂۂقŌ */
			if (level > dali.level) {
				if (dali.level < dali_variable.var.eeprom_minimum_level) {
					dali.level = dali_variable.var.eeprom_minimum_level;
				}

				fade_direction = FADE_TIME_UP;
				level_change = (level - dali.level);
			} else if (level < dali.level) {
				fade_direction = FADE_TIME_DOWN;
				level_change = (dali.level - level);
			} else {
				/* ɐ */
				fade_direction = FADE_STOP;
				level_change = 0x00;
			}
		}

		if (dapc_sequence == true) {
			/* xƂĒωx1 */
			current_fade = 1;
			dapc_sequence_time = W200MS;
		} else {
			current_fade = dali_variable.var.eeprom_fade_time;
		}

		/* VڕWِݒ */
		dali_variable.var.eeprom_target_level = level;
		eeprom_flag |= PAGE0_UPDATE;

		if (current_fade == 0) {
			/* ω */
			if (fast_fade_time == 0) {
				dali.level = level;
				fade_direction = FADE_DIRECT;
			} else {
				/* : 2^23 / (0.025*244*fast_fade_time) */
				step = ((uint32_t)40 <<	23) /
						(fast_fade_time * DALI_PWM_CLOCK_HZ);
				need_fade = true;
				status_information |= FADE_RUNNING;
			}
		} else {
			step = flash_inv_fadetime_val[current_fade];
			need_fade = true;
			status_information |= FADE_RUNNING;
		}

		/* ̉ZɒӂǂÂɐ؂l߂ꂽԌʁ`𓾂܂
		 * B */
		fade_step = step;
		fade_step = fade_step * level_change;
		/* flash_inv_fadetime_valɊi[ꂽlł̈ړ̂߁A1ޯĉړ */
		fade_step = fade_step >> 1;
		status_information |= LAMP_ARC_POWER_ON;
	}

	int_fade_step = fade_step;
	int_dali.long_level = dali.long_level;
	dali_hal_enable_fading_interrupt();
}

uint16_t dali_cmd_process_normal(dali_slave_service_info_t *slave_info,
		uint8_t repeat_flag)
{
	if ((slave_info->rec_data >= REFERENCE_SYSTEM_POWER) &&
			(slave_info->rec_data <= QUERY_EXTENDED_VERSION_NUMBER)) {
		return dali_cmd_process_extended_application(slave_info,
				repeat_flag);
	} else {
		return dali_cmd_process_common(slave_info, repeat_flag);
	}
}

uint16_t dali_cmd_process_common(dali_slave_service_info_t *slave_info,
		uint8_t repeat_flag)
{
	uint16_t ret;
	uint8_t current_fade;
	uint8_t temp;
	uint8_t i;
	uint8_t low;

	if ((slave_info->rec_data >= RESET) &&
			(slave_info->rec_data <= ENABLE_WRITE_MEMORY)) {
		if (repeat_flag == false) {
			return RECEIVE_FIRST;
		}
	}

	ret = ANSWER_NO;
	write_memory_enabled = false;
	dali_hal_disable_fading_interrupt();
	dali.long_level = int_dali.long_level;

	switch (slave_info->rec_data) {
	/* ωȂŏƖB */
	case OFF:
		dali_variable.var.eeprom_target_level = 0;
		eeprom_flag |= PAGE0_UPDATE;
		status_information	&= ~(LAMP_ARC_POWER_ON + FADE_RUNNING +
				LIMIT_ERROR + POWER_FAILURE);
		dali.long_level = 0;
		fade_direction = FADE_DIRECT;
		dapc_sequence = false;
		power_on_flag = false;
		break;

	/* ƖONȂAI񂾒ωxp200msɋB */
	case UP:
		if (status_information & LAMP_ARC_POWER_ON) {
			fade_direction = FADE_RATE_UP;
			fade_time = W200MS;
			current_fade = dali_variable.var.eeprom_fade_rate;
			fade_step = flash_fade_rate_val[current_fade];
			/* flash_fade_rate_valɊi[ꂽlł̈ړ̂7ޯĈړ */
			fade_step = fade_step << 7;
			need_fade = true;
			status_information |= FADE_RUNNING;
		} else {
			fade_direction = FADE_STOP;
		}

		dapc_sequence = false;
		power_on_flag = false;
		break;

	/* ƖONȂAI񂾒ωxp200msɎキB */
	case DOWN:
		if (status_information & LAMP_ARC_POWER_ON) {
			fade_direction = FADE_RATE_DOWN;
			fade_time = W200MS;
			current_fade = dali_variable.var.eeprom_fade_rate;
			fade_step = flash_fade_rate_val[current_fade];
			/* flash_fade_rate_valɊi[ꂽlł̈ړ̂7ޯĈړ */
			fade_step = fade_step << 7;
			need_fade = true;
			status_information |= FADE_RUNNING;
		} else {
			fade_direction = FADE_STOP;
		}

		dapc_sequence = false;
		power_on_flag = false;
		break;

	/* ƖONȂAωȂ1iۂarcdقݒ */
	case STEP_UP:
		if (status_information & LAMP_ARC_POWER_ON) {
			if (dali_variable.var.eeprom_target_level <
					dali_variable.var.eeprom_maximum_level)
			{
				dali.level = dali.level + 1;
				dali_variable.var.eeprom_target_level =	dali.level;
				eeprom_flag |= PAGE0_UPDATE;
				status_information &= ~LIMIT_ERROR;
			} else {
				status_information |= LIMIT_ERROR;
			}

			fade_direction = FADE_DIRECT;
		}

		dapc_sequence = false;
		power_on_flag = false;
		break;

	/* ƖONȂAωȂ1iႢۂarcdقݒ */
	case STEP_DOWN:
		if (status_information & LAMP_ARC_POWER_ON) {
			if (dali_variable.var.eeprom_target_level >
					dali_variable.var.eeprom_minimum_level)
			{
				dali.level = dali.level - 1;
				dali_variable.var.eeprom_target_level =	dali.level;
				eeprom_flag |= PAGE0_UPDATE;
				status_information &= ~LIMIT_ERROR;
			} else {
				status_information |= LIMIT_ERROR;
			}

			fade_direction = FADE_DIRECT;
		}

		dapc_sequence = false;
		power_on_flag = false;
		break;

	/* ۂarcdقőlɐݒAOFFȂONɐ؂ւ */
	case RECALL_MAX_LEVEL:
		status_information |= LAMP_ARC_POWER_ON;
		status_information &= ~(LIMIT_ERROR + POWER_FAILURE);
		dali.level = dali_variable.var.eeprom_maximum_level;
		dali_variable.var.eeprom_target_level = dali.level;
		eeprom_flag |= PAGE0_UPDATE;
		fade_direction = FADE_DIRECT;
		dapc_sequence = false;
		power_on_flag = false;
		break;

	/* ۂarcdقŏlɐݒAOFFȂONɐ؂ւ */
	case RECALL_MIN_LEVEL:
		status_information |= LAMP_ARC_POWER_ON;
		status_information &= ~(LIMIT_ERROR + POWER_FAILURE);
		dali.level = dali_variable.var.eeprom_minimum_level;
		dali_variable.var.eeprom_target_level = dali.level;
		eeprom_flag |= PAGE0_UPDATE;
		fade_direction = FADE_DIRECT;
		dapc_sequence = false;
		power_on_flag = false;
		break;

	/* ωȂ1iႢۂarcdقݒAɍŏقȂAOFFɐ؂
	 * ւ */
	case STEP_DOWN_AND_OFF:
		if (dali.level <= dali_variable.var.eeprom_minimum_level) {
			dali_variable.var.eeprom_target_level = 0;
			eeprom_flag |= PAGE0_UPDATE;
			dali.long_level = 0;
			status_information &= ~LAMP_ARC_POWER_ON;
		} else {
			dali.level = dali.level - 1;
			dali_variable.var.eeprom_target_level = dali.level;
			eeprom_flag |= PAGE0_UPDATE;
		}

		status_information &= ~(LIMIT_ERROR + POWER_FAILURE);
		fade_direction = FADE_DIRECT;
		dapc_sequence = false;
		power_on_flag = false;
		break;

	/* ωȂ1iۂarcdقݒAOFFȂAŏقɐݒ */
	case ON_AND_STEP_UP:
		if (dali.level == 0) {
			/* ŏɐݒ */
			status_information |= LAMP_ARC_POWER_ON;
			dali.level = dali_variable.var.eeprom_minimum_level;
			dali_variable.var.eeprom_target_level = dali.level;
			eeprom_flag |= PAGE0_UPDATE;
			status_information &= ~LIMIT_ERROR;
		} else if (dali.level <
				dali_variable.var.eeprom_maximum_level) {
			/* ωȂق𑝉 */
			dali.level = dali.level + 1;
			dali_variable.var.eeprom_target_level = dali.level;
			eeprom_flag |= PAGE0_UPDATE;
			status_information &= ~LIMIT_ERROR;
		} else {
			status_information |= LIMIT_ERROR;
		}

		status_information &= ~POWER_FAILURE;
		fade_direction = FADE_DIRECT;
		dapc_sequence = false;
		power_on_flag = false;
		break;

	/* arcd͐(DAPC)菇̊JnLB */
	case ENABLE_DAPC_SEQUENCE:
		dapc_sequence = true;
		dapc_sequence_time = W200MS;
		break;

	/* ۂ̒ωԂpeeprom_scene xɊi[lɎۂarcd
	 * ݒ */
	case GO_TO_SCENE0:
	case GO_TO_SCENE1:
	case GO_TO_SCENE2:
	case GO_TO_SCENE3:
	case GO_TO_SCENE4:
	case GO_TO_SCENE5:
	case GO_TO_SCENE6:
	case GO_TO_SCENE7:
	case GO_TO_SCENE8:
	case GO_TO_SCENE9:
	case GO_TO_SCENE10:
	case GO_TO_SCENE11:
	case GO_TO_SCENE12:
	case GO_TO_SCENE13:
	case GO_TO_SCENE14:
	case GO_TO_SCENE15:
		temp = dali_variable.var.eeprom_scene[slave_info->
				rec_data &	0x0F];
		/* ֐arcdق͍ŏ/ő͈ٔ͂ɂĐ܂B */
		dali_cmd_direct_arc_power_control(temp);
		break;

	/* Ұׂݒؾ */
	case RESET:
		dali.long_level = 0xfe000000;
		dali_variable.var.eeprom_target_level = POWER_MAX;
		dali_variable.var.eeprom_power_on_level = POWER_MAX;
		dali_variable.var.eeprom_system_failure_level = POWER_MAX;
		dali_variable.var.eeprom_minimum_level = POWER_MIN;
		dali_variable.var.eeprom_maximum_level = POWER_MAX;
		dali_variable.var.eeprom_fade_rate = 0x07;
		dali_variable.var.eeprom_fade_time = 0x00;

		dali_variable.var.eeprom_random_address.high = 0xFF;
		dali_variable.var.eeprom_random_address.mid = 0xFF;
		dali_variable.var.eeprom_random_address.low = 0xFF;

		dali_variable.var.eeprom_group_0_7 = 0x00;
		dali_variable.var.eeprom_group_8_15 = 0x00;
		for (i = 0; i < 16; i++) {
			dali_variable.var.eeprom_scene[i] = POWER_MASK;
		}
		fast_fade_time = 0x00;
		dali_variable.var.eeprom_fast_fade_time = 0x00;
		dali_variable.var.eeprom_dimming_curve = LOGARITHMIC;
		eeprom_flag |= PAGE0_UPDATE;

		search_address.high = 0xFF;
		search_address.mid = 0xFF;
		search_address.low = 0xFF;
		status_information &= ~(POWER_FAILURE + FADE_RUNNING +
				LIMIT_ERROR + LAMP_FAILURE);
		status_information |= RESET_STATE + LAMP_ARC_POWER_ON;
		failure_status &= ~CURRENT_PROTECTOR_ACTIVE;

		fade_direction = FADE_DIRECT;
		break;

	/* dtrɌ݂̌قi[ */
	case STORE_ACTUAL_LEVEL_IN_THE_DTR:
		dtr = dali.level;
		break;

	/* őقƂdtrɒli[ */
	case STORE_THE_DTR_AS_MAX_LEVEL:
		if (dtr > dali_variable.var.eeprom_minimum_level) {
			dali_variable.var.eeprom_maximum_level = dtr;
		} else {
			/* ő͍ŏ̉ɐݒ肷邱Ƃł܂B */
			dali_variable.var.eeprom_maximum_level =
					dali_variable.var.eeprom_minimum_level;
		}

		if (dtr == POWER_MASK) {
			dali_variable.var.eeprom_maximum_level = POWER_MAX;
		}

		temp = dali_variable.var.eeprom_maximum_level;
		if (dali.level > temp) {
			dali.level = temp;
			dali_variable.var.eeprom_target_level = temp;
			fade_direction = FADE_DIRECT;
		}
		eeprom_flag |= PAGE0_UPDATE;
		break;

	/* ŏقƂdtrɒli[ */
	case STORE_THE_DTR_AS_MIN_LEVEL:
		if (dtr < dali_variable.var.eeprom_physical_minimum_level) {
			dtr = dali_variable.var.eeprom_physical_minimum_level;
		} else if (dtr > dali_variable.var.eeprom_maximum_level) {
			dtr = dali_variable.var.eeprom_maximum_level;
		}
		dali_variable.var.eeprom_minimum_level = dtr;

		if ((dali.level < dtr) && (dali.level != POWER_OFF)) {
			dali.level = dtr;
			dali_variable.var.eeprom_target_level = dtr;
			fade_direction = FADE_DIRECT;
		}
		eeprom_flag |= PAGE0_UPDATE;
		break;

	/* яQقƂdtrɒli[ */
	case STORE_THE_DTR_AS_SYSTEM_FAILURE_LEVEL:
		dali_variable.var.eeprom_system_failure_level = dtr;
		eeprom_flag |= PAGE0_UPDATE;
		break;

	/* dONقƂdtrɒli[ */
	case STORE_THE_DTR_AS_POWER_ON_LEVEL:
		dali_variable.var.eeprom_power_on_level = dtr;
		eeprom_flag |= PAGE0_UPDATE;
		break;

	/* ωԂƂdtrɒli[ */
	case STORE_THE_DTR_AS_FADE_TIME:
		/* eeprom_fade_timeɑ΂L͈͂0`15łB */
		if (dtr > 0x0F) {
			dtr = 0x0F;
		}

		dali_variable.var.eeprom_fade_time = dtr;
		eeprom_flag |= PAGE0_UPDATE;
		break;

	/* ωxƂdtrɒli[ */
	case STORE_THE_DTR_AS_FADE_RATE:
		/* eeprom_fade_rateɑ΂L͈͂1`15łB */
		if (dtr > 0x0F) {
			dtr = 0x0F;
		} else if(dtr == 0x00) {	// LED1ɑ΂ĂOK
			dtr = 1;
		}

		dali_variable.var.eeprom_fade_rate = dtr;
		eeprom_flag |= PAGE0_UPDATE;
		break;

	/* ް]ڼ޽̒leeprom_scene XXXXp̐VlƂĊi[ׂ
	 * B */
	case STORE_THE_DTR_AS_SCENE0:
	case STORE_THE_DTR_AS_SCENE1:
	case STORE_THE_DTR_AS_SCENE2:
	case STORE_THE_DTR_AS_SCENE3:
	case STORE_THE_DTR_AS_SCENE4:
	case STORE_THE_DTR_AS_SCENE5:
	case STORE_THE_DTR_AS_SCENE6:
	case STORE_THE_DTR_AS_SCENE7:
	case STORE_THE_DTR_AS_SCENE8:
	case STORE_THE_DTR_AS_SCENE9:
	case STORE_THE_DTR_AS_SCENE10:
	case STORE_THE_DTR_AS_SCENE11:
	case STORE_THE_DTR_AS_SCENE12:
	case STORE_THE_DTR_AS_SCENE13:
	case STORE_THE_DTR_AS_SCENE14:
	case STORE_THE_DTR_AS_SCENE15:
		dali_variable.var.eeprom_scene[slave_info->rec_data & 0x0F] = dtr;
		eeprom_flag |= PAGE0_UPDATE;
		break;

	/* eeprom_scene XXXX̐ޱ폜eeprom_sceneڼ޽XXXX0b11111111('
	 * '܂'ω')i[Ӗ܂B */
	case REMOVE_FROM_SCENE0:
	case REMOVE_FROM_SCENE1:
	case REMOVE_FROM_SCENE2:
	case REMOVE_FROM_SCENE3:
	case REMOVE_FROM_SCENE4:
	case REMOVE_FROM_SCENE5:
	case REMOVE_FROM_SCENE6:
	case REMOVE_FROM_SCENE7:
	case REMOVE_FROM_SCENE8:
	case REMOVE_FROM_SCENE9:
	case REMOVE_FROM_SCENE10:
	case REMOVE_FROM_SCENE11:
	case REMOVE_FROM_SCENE12:
	case REMOVE_FROM_SCENE13:
	case REMOVE_FROM_SCENE14:
	case REMOVE_FROM_SCENE15:
		dali_variable.var.eeprom_scene[slave_info->rec_data & 0x0F] = POWER_MASK;
		eeprom_flag |= PAGE0_UPDATE;
		break;

	/* ޱXXXXQɒǉׂłB */
	case ADD_TO_GROUP0:
	case ADD_TO_GROUP1:
	case ADD_TO_GROUP2:
	case ADD_TO_GROUP3:
	case ADD_TO_GROUP4:
	case ADD_TO_GROUP5:
	case ADD_TO_GROUP6:
	case ADD_TO_GROUP7:
		low = slave_info->rec_data & 0x07;
		temp = dali_variable.var.eeprom_group_0_7;
		temp = temp | (1 << low);
		dali_variable.var.eeprom_group_0_7 = temp;
		eeprom_flag |= PAGE0_UPDATE;
		break;

	case ADD_TO_GROUP8:
	case ADD_TO_GROUP9:
	case ADD_TO_GROUP10:
	case ADD_TO_GROUP11:
	case ADD_TO_GROUP12:
	case ADD_TO_GROUP13:
	case ADD_TO_GROUP14:
	case ADD_TO_GROUP15:
		low = slave_info->rec_data & 0x07;
		temp = dali_variable.var.eeprom_group_8_15;
		temp = temp | (1 << low);
		dali_variable.var.eeprom_group_8_15 = temp;
		eeprom_flag |= PAGE0_UPDATE;
		break;

	/* ޱXXXXQ폜ׂłB */
	case REMOVE_FROM_GROUP0:
	case REMOVE_FROM_GROUP1:
	case REMOVE_FROM_GROUP2:
	case REMOVE_FROM_GROUP3:
	case REMOVE_FROM_GROUP4:
	case REMOVE_FROM_GROUP5:
	case REMOVE_FROM_GROUP6:
	case REMOVE_FROM_GROUP7:
		low = slave_info->rec_data & 0x07;
		temp = dali_variable.var.eeprom_group_0_7;
		temp = temp & ~(1 << low);
		dali_variable.var.eeprom_group_0_7 = temp;
		eeprom_flag |= PAGE0_UPDATE;
		break;

	case REMOVE_FROM_GROUP8:
	case REMOVE_FROM_GROUP9:
	case REMOVE_FROM_GROUP10:
	case REMOVE_FROM_GROUP11:
	case REMOVE_FROM_GROUP12:
	case REMOVE_FROM_GROUP13:
	case REMOVE_FROM_GROUP14:
	case REMOVE_FROM_GROUP15:
		low = slave_info->rec_data & 0x07;
		temp = dali_variable.var.eeprom_group_8_15;
		temp = temp & ~(1 << low);
		dali_variable.var.eeprom_group_8_15 = temp;
		eeprom_flag |= PAGE0_UPDATE;
		break;

	/* VZڽƂdtrɒlۑ */
	case STORE_DTR_AS_SHORT_ADDRESS:
		if (dtr == ADDR_MASK) {
			dali_variable.var.eeprom_short_address = ADDR_MASK;
			eeprom_flag |= PAGE0_UPDATE;
			status_information |= MISSING_SHORT_ADDR;
		} else if ((dtr & 0x81) == 0x01) {
			/* dtr=0AAA AAA1eeprom_short_address00AAAAAA𓾂邽߂1ޯĉ
			 * ړKv */
			dali_variable.var.eeprom_short_address = (dtr >> 1);
			eeprom_flag |= PAGE0_UPDATE;
			status_information &= ~MISSING_SHORT_ADDR;
		}
		break;

	/* 㑱؂ւ݂̏ */
	case ENABLE_WRITE_MEMORY:
		write_memory_enabled = true;
		break;

	/* ԏɊ֘A₢킹 */
	case QUERY_STATUS:
		if (true == dali_cmd_check_reset_state()) {
			status_information |= RESET_STATE;
		} else {
			status_information &= ~RESET_STATE;
		}

		ret = status_information;
		break;

	case QUERY_CONTROL_GEAR:
		/* ޱ܂B */
		ret = ANSWER_YES;
		break;

	case QUERY_LAMP_FAILURE:
		/* ޯ1: ƖQ; 0=OK */
		if ((status_information & LAMP_FAILURE) != 0x00) {
			ret = ANSWER_YES;
		}
		break;

	case QUERY_LAMP_POWER_ON:
		/* ޯ2: ƖarcdON; 0=OFF */
		if ((status_information & LAMP_ARC_POWER_ON) != 0x00) {
			ret = ANSWER_YES;
		}
		break;

	case QUERY_LIMIT_ERROR:
		/* ޯ3(₢킹): xُ; 0=Ōɗvꂽarcdقŏƍ
		 * يԁA܂OFF */
		if ((status_information & LIMIT_ERROR) != 0x00) {
			ret = ANSWER_YES;
		}
		break;

	case QUERY_RESET_STATE:
		if (true == dali_cmd_check_reset_state()) {
			status_information |= RESET_STATE;
			ret = ANSWER_YES;
		} else {
			status_information &= ~RESET_STATE;
		}
		break;

	case QUERY_MISSING_SHORT_ADDRESS:
		if ((status_information & MISSING_SHORT_ADDR) != 0x00) {
			ret = ANSWER_YES;
		}
		break;

	case QUERY_VERSION_NUMBER:
		ret = dali_variable.var.eeprom_version_number;
		break;

	case QUERY_CONTENT_DTR:
		ret = dtr;
		break;

	case QUERY_DEVICE_TYPE:
		ret = DEVICE_TYPE;
		break;

	case QUERY_PHYSICAL_MINIMUM_LEVEL:
		ret = dali_variable.var.eeprom_physical_minimum_level;
		break;

	case QUERY_POWER_FAILURE:
		/* ޯ7(₢킹): "POWER FAILURE"? "0" = "No"; "RESET"܂͍Ō̓d
		 * ONarcd͐䖽߂MĂ */
		if ((status_information & POWER_FAILURE) != 0x00) {
			ret = ANSWER_YES;
		}
		break;

	case QUERY_CONTENT_DTR1:
		ret = dtr1;
		break;

	case QUERY_CONTENT_DTR2:
		ret = dtr2;
		break;

	/* arcҰݒɊ֘A₢킹 */
	case QUERY_ACTUAL_LEVEL:
		if ((status_information & LAMP_FAILURE) != 0x00) {
			/* ƖQAՕŉ */
			ret = POWER_MASK;
		} else {
			ret = dali.level;
		}
		break;

	case QUERY_MAX_LEVEL:
		ret = dali_variable.var.eeprom_maximum_level;
		break;

	case QUERY_MIN_LEVEL:
		ret = dali_variable.var.eeprom_minimum_level;
		break;

	case QUERY_POWER_ON_LEVEL:
		ret = dali_variable.var.eeprom_power_on_level;
		break;

	case QUERY_SYSTEM_FAILURE_LEVEL:
		ret = dali_variable.var.eeprom_system_failure_level;
		break;

	case QUERY_FADE_TIME_RATE:
		ret = (dali_variable.var.eeprom_fade_time << 4) |
				dali_variable.var.eeprom_fade_rate;
		break;

	case QUERY_SCENE_LEVEL0:
	case QUERY_SCENE_LEVEL1:
	case QUERY_SCENE_LEVEL2:
	case QUERY_SCENE_LEVEL3:
	case QUERY_SCENE_LEVEL4:
	case QUERY_SCENE_LEVEL5:
	case QUERY_SCENE_LEVEL6:
	case QUERY_SCENE_LEVEL7:
	case QUERY_SCENE_LEVEL8:
	case QUERY_SCENE_LEVEL9:
	case QUERY_SCENE_LEVEL10:
	case QUERY_SCENE_LEVEL11:
	case QUERY_SCENE_LEVEL12:
	case QUERY_SCENE_LEVEL13:
	case QUERY_SCENE_LEVEL14:
	case QUERY_SCENE_LEVEL15:
		ret	= dali_variable.var.eeprom_scene[slave_info->rec_data & 0x0F];
		break;

	case QUERY_GROUPS_0_7:
		ret = dali_variable.var.eeprom_group_0_7;
		break;

	case QUERY_GROUPS_8_15:
		ret = dali_variable.var.eeprom_group_8_15;
		break;

	case QUERY_RANDOM_ADDRESS_H:
		ret = dali_variable.var.eeprom_random_address.high;
		break;

	case QUERY_RANDOM_ADDRESS_M:
		ret = dali_variable.var.eeprom_random_address.mid;
		break;

	case QUERY_RANDOM_ADDRESS_L:
		ret = dali_variable.var.eeprom_random_address.low;
		break;

	case READ_MEMORY_LOCATION:
		/* ݸI */
		if (dtr1 == BANK0) {
			if (dtr <= BANK0_LAST_MEMORY_LOCATION) {
				ret	= dali_memory.bank.eeprom_memory_bank0[dtr++];
				dtr2 = dali_memory.bank.eeprom_memory_bank0[dtr];
			}
		} else if (dtr1 == BANK1) {
			if (dtr <= BANK1_LAST_MEMORY_LOCATION) {
				ret	= dali_memory.bank.eeprom_memory_bank1[dtr++];
				dtr2 = dali_memory.bank.eeprom_memory_bank1[dtr];
			}
		}
		break;

	default:
		break;
	}
	int_fade_step = fade_step;
	int_dali.long_level = dali.long_level;
	dali_hal_enable_fading_interrupt();

	device_enabled = false;
	return ret;
}

uint16_t dali_cmd_process_extended_application(dali_slave_service_info_t *slave_info,
		uint8_t repeat_flag)
{
	uint16_t ret;
	uint8_t temp;

	write_memory_enabled = false;
	if ((slave_info->rec_data >= REFERENCE_SYSTEM_POWER) &&
			(slave_info->rec_data <= STORE_DTR_AS_FAST_FADE_TIME)) {
		if (repeat_flag == false) {
			return RECEIVE_FIRST;
		}
	}

	ret = ANSWER_NO;
	if (device_enabled == false) {
		return ret;
	}
	
	dali_hal_disable_fading_interrupt();

	switch (slave_info->rec_data) {
	case REFERENCE_SYSTEM_POWER:
	case ENABLE_CURRENT_PROTECTOR:
	case DISABLE_CURRENT_PROTECTOR:
		break;

	case SELECT_DIMMING_CURVE:
		if (dtr <= LINEAR) {
			dali_variable.var.eeprom_dimming_curve = dtr;
			temp = failure_status & REFERRENCE_MEASUREMENT_FAILED;
			if (dtr == LOGARITHMIC) {
				operation_mode &= ~NON_LOGARITHMIC_DIMMING_CURVE_ACTIVE;
				dali_variable.var.eeprom_failure_status_operation_mode = temp;
			} else {
				operation_mode |= NON_LOGARITHMIC_DIMMING_CURVE_ACTIVE;
				dali_variable.var.eeprom_failure_status_operation_mode =
						temp | NON_LOGARITHMIC_DIMMING_CURVE_ACTIVE;
			}
			eeprom_flag |= PAGE0_UPDATE;
		}
		break;

	case STORE_DTR_AS_FAST_FADE_TIME:
		if (dtr == 0) {
			fast_fade_time = 0;
		} else if (dtr < dali_variable.var.eeprom_min_fast_fade_time) {
			fast_fade_time = dali_variable.var.eeprom_min_fast_fade_time;
		} else if (dtr <= MAX_FAST_FADE_TIME) {
			fast_fade_time = dtr;
		} else {
			fast_fade_time = MAX_FAST_FADE_TIME;
		}

		dali_variable.var.eeprom_fast_fade_time = fast_fade_time;
		eeprom_flag |= PAGE0_UPDATE;
		break;

	case QUERY_GEAR_TYPE:
		ret = dali_variable.var.eeprom_gear_type;
		break;

	case QUERY_DIMMING_CURVE:
		ret = dali_variable.var.eeprom_dimming_curve;
		break;

	case QUERY_POSSIBLE_OPERATING_MODES:
		ret = dali_variable.var.eeprom_possible_operation_modes;
		break;

	case QUERY_FEATURES:
		ret = optional_features;
		break;

	case QUERY_FAILURE_STATUS:
		ret = failure_status;
		break;

	case QUERY_SHORT_CIRCUIT:
	case QUERY_OPEN_CIRCUIT:
	case QUERY_LOAD_DECREASE:
	case QUERY_LOAD_INCREASE:
	case QUERY_CURRENT_PROTECTOR_ACTIVE:
	case QUERY_THERMAL_SHUT_DOWN:
	case QUERY_THERMAL_OVERLOAD:
	case QUERY_REFERENCE_RUNNING:
	case QUERY_REFERENCE_MEASUREMENT_FAILED:
	case QUERY_CURRENT_PROTECTOR_ENABLED:
		break;

	case QUERY_OPERATING_MODE:
		ret = operation_mode;
		break;

	case QUERY_FAST_FADE_TIME:
		ret = fast_fade_time;
		break;

	case QUERY_MIN_FAST_FADE_TIME:
		ret = dali_variable.var.eeprom_min_fast_fade_time;
		break;

	case QUERY_EXTENDED_VERSION_NUMBER:
		ret = EXTENDED_VER_NUM;
		break;

	default:
		break;
	}

	dali_hal_enable_fading_interrupt();

	device_enabled = false;
	return ret;
}

uint16_t dali_cmd_process_special(dali_slave_service_info_t *slave_info,
		uint8_t repeat_flag)
{
	uint16_t ret;
	uint8_t temp_short_addr;
	uint8_t temp = 0;
	uint8_t enable_device_cmd = 0;
	uint8_t enable_memory_write = 0;
	uint32_t temp_random_addr, temp_search_addr;

	ret = ANSWER_NO;

	if ((slave_info->rec_addr >= RANDOMISE) &&
			(slave_info->rec_addr <= PHYSICAL_SELECTION)) {
		if (w15min_waiting_time == 0) {
			return ret;
		}
	}
	dali_hal_disable_fading_interrupt();
	temp_random_addr
		= ((uint32_t)dali_variable.var.eeprom_random_address.high << 16) +
			((uint32_t)dali_variable.var.eeprom_random_address.mid << 8) +
			(uint32_t)dali_variable.var.eeprom_random_address.low;

	temp_search_addr
		= ((uint32_t)search_address.high << 16) +
			((uint32_t)search_address.mid << 8) +
			(uint32_t)search_address.low;
	/* Zڽ͓xX0AAA AAA1̌`œ]A͂00AA AAAA`ɕύX
	 * ܂B */
	temp_short_addr = ((slave_info->rec_data & ADDR_SHORT_A) >> 1);

	switch (slave_info->rec_addr) {
	case TERMINATE:
		/* ԏ~ */
		w15min_waiting_time = 0;

		physical_is_selected = false;
		physical_selection_mode = false;
		break;

	case DATA_TRANSFER_REGISTER:
		dtr = slave_info->rec_data;
		break;

	case INITIALISE:
		if (repeat_flag == false) {
			dali_hal_enable_fading_interrupt();
			return RECEIVE_FIRST;
		}

		if (slave_info->rec_data == 0) {
			temp = 1;
		} else if (slave_info->rec_data == ADDR_MASK) {
			if (dali_variable.var.eeprom_short_address == ADDR_MASK) {
				temp = 1;
			}
		} else if ((slave_info->rec_data & 0x81) == 0x01) {
			/* Zڽ */
			if (temp_short_addr ==
					dali_variable.var.eeprom_short_address)
			{
				temp = 1;
			}
		}

		if (temp) {
			withdraw = 0;
			physical_is_selected = false;
			physical_selection_mode = false;
			w15min_waiting_time = W15MIN;
		} else {
			w15min_waiting_time = 0;
		}
		break;

	case RANDOMISE:
		if (repeat_flag == false) {
			dali_hal_enable_fading_interrupt();
			return RECEIVE_FIRST;
		}

		/* p̎ƂČ݂̌vlgp */
		srand(dali_hal_get_seed0_value());
		dali_variable.var.eeprom_random_address.high = rand();
		dali_variable.var.eeprom_random_address.mid = rand();
		srand(dali_hal_get_seed1_value());
		dali_variable.var.eeprom_random_address.low = rand();
		eeprom_flag |= PAGE0_UPDATE;
		break;

	case COMPARE:
		if (physical_selection_mode == false) {
			if (withdraw == 0) {
				if (temp_random_addr <= temp_search_addr) {
					ret = ANSWER_YES;
				}
			}
		}
		break;

	case WITHDRAW:
		/* P׸ސݒ */
		if (temp_random_addr == temp_search_addr) {
			withdraw = 1;
		}
		break;

	case SEARCHADDRH:
		search_address.high = slave_info->rec_data;
		break;

	case SEARCHADDRM:
		search_address.mid = slave_info->rec_data;
		break;

	case SEARCHADDRL:
		search_address.low = slave_info->rec_data;
		break;

	case PROGRAM_SHORT_ADDRESS:
		if (slave_info->rec_data == ADDR_MASK) {
			/* Zڽ0xFF͍폜ꂽZڽӖ܂B */
			dali_variable.var.eeprom_short_address = ADDR_MASK;
			eeprom_flag |= PAGE0_UPDATE;
			status_information |= MISSING_SHORT_ADDR;
		} else if ((temp_random_addr == temp_search_addr) ||
				(physical_is_selected == true)) {
			/* I΂ꂽڽ */
			if ((slave_info->rec_data & 0x01) == 0x01) {
				/* EEPROM00AA AAAAƂĊi[ */
				dali_variable.var.eeprom_short_address =
						temp_short_addr;
				eeprom_flag |= PAGE0_UPDATE;
				status_information &= ~MISSING_SHORT_ADDR;
			}
		}
		break;

	case VERIFY_SHORT_ADDRESS:
		if (dali_variable.var.eeprom_short_address ==
				temp_short_addr) {
			ret = ANSWER_YES;
		}
		break;

	case QUERY_SHORT_ADDRESS:
		if (physical_selection_mode == true) {
			if (physical_is_selected == true) {
				ret	= (dali_variable.var.eeprom_short_address << 1) | 0x01;
			}
		} else if (temp_random_addr == temp_search_addr) {
			ret	= (dali_variable.var.eeprom_short_address << 1) | 0x01;
		}
		break;

	case PHYSICAL_SELECTION:
		physical_selection_mode = true;
		break;

	case ENABLE_DEVICE_TYPE:
		if (slave_info->rec_data == DEVICE_TYPE) {
			device_enabled = true;
		}

		enable_device_cmd = 1;
		break;

	case DATA_TRANSFER_REGISTER_1:
		dtr1 = slave_info->rec_data;
		break;

	case DATA_TRANSFER_REGISTER_2:
		dtr2 = slave_info->rec_data;
		break;

	case WRITE_MEMORY_LOCATION:
		if (write_memory_enabled == false) {
			break;
		}

		enable_memory_write = 1;
		temp = 0;
		if (dtr1 == BANK1) {
			if (dtr < 0x02) {
				/* ǂݍݐp */
				temp = 1;
			} else if ((dtr == 0x02) || (dtr == 0x0F)) { 
				/* ǂݏ */
				temp = 2;
			} else if ((dtr > 0x02) && (dtr < 0x0F)) {
				/* {\ */
				if (dali_memory.bank.eeprom_memory_bank1[2] ==
						NOT_LOCK) {
					temp = 2;
				}
			}

			/* ݸ1͈͓łdtrʒuwqXV */
			if (temp > 0) {
				/* ؏ */
				if (temp == 2) {
					/* CSXV */
					temp = dali_memory.bank.eeprom_memory_bank1[1] +
							dali_memory.bank.eeprom_memory_bank1[dtr]
							- slave_info->rec_data;

					dali_memory.bank.eeprom_memory_bank1[dtr] = slave_info->rec_data;
					dali_memory.bank.eeprom_memory_bank1[1] = temp;
					ret = slave_info->rec_data;
					eeprom_flag |= PAGE1_UPDATE;
				}
				dtr++;
			}
		}
		break;

	default:
		break;
	}

	dali_hal_enable_fading_interrupt();

	if (enable_device_cmd == 0) {
		device_enabled = false;
	}

	if (enable_memory_write == 0) {
		write_memory_enabled = false;
	}

	return ret;
}

/**
 *  \brief ؾďԂ
 *
 *  \returns trueؾďԁAfalse͂ȊO
 */
bool dali_cmd_check_reset_state(void)
{
	uint8_t i;

	if (dali.level != POWER_MAX) {
		return false;
	}

	if (dali_variable.var.eeprom_power_on_level != POWER_MAX) {
		return false;
	}

	if (dali_variable.var.eeprom_system_failure_level != POWER_MAX) {
		return false;
	}

	if (dali_variable.var.eeprom_minimum_level != POWER_MIN) {
		return false;
	}

	if (dali_variable.var.eeprom_maximum_level != POWER_MAX) {
		return false;
	}

	if (dali_variable.var.eeprom_fade_rate != 0x07) {
		return false;
	}

	if (dali_variable.var.eeprom_fade_time != 0x00) {
		return false;
	}

	if (dali_variable.var.eeprom_random_address.high != 0xFF) {
		return false;
	}

	if (dali_variable.var.eeprom_random_address.mid != 0xFF) {
		return false;
	}

	if (dali_variable.var.eeprom_random_address.low != 0xFF) {
		return false;
	}

	if (dali_variable.var.eeprom_group_0_7 != 0x00) {
		return false;
	}

	if (dali_variable.var.eeprom_group_8_15 != 0x00) {
		return false;
	}

	for (i = 0; i < 16; i++) {
		if (dali_variable.var.eeprom_scene[i] != POWER_MASK) {
			return false;
		}
	}

	if (search_address.high != 0xFF) {
		return false;
	}

	if (search_address.mid != 0xFF) {
		return false;
	}

	if (search_address.low != 0xFF) {
		return false;
	}
	if(operation_mode & NON_LOGARITHMIC_DIMMING_CURVE_ACTIVE) {
		return false;
	}
	
	if (dali_variable.var.eeprom_fast_fade_time != 0x00) {
		return false;
	}
	return true;
}

/**
 *  \brief DALIް𒼐PWMo͂ɏ݁AωȂ
 *
 *  \param  dali_value ݒ肷ׂd
 */
void dali_cmd_set_pwm_output(uint8_t dali_value)
{
	uint16_t temp_val;

	if (dali_variable.var.eeprom_dimming_curve == LOGARITHMIC) {
		/* ޲Ė24ޯĒli[12ޯPWMl̏4ޯ */
		temp_val = (uint16_t)flash_high_pwm_val[dali_value >> 1];

		if ((dali_value & 0x01) == 0x00) {
			/* ް͉4ޯĂɊi[ */
			temp_val = (temp_val & 0x0F) << 8;
		} else {
			/* ް͏4ޯĂɊi[ */
			temp_val = (temp_val & 0xF0) << 4;
		}
		/* ޲Ēǉ */
		temp_val += (uint16_t)flash_low_pwm_val[dali_value];
	} else {
		/*  n~4095/254 */
		temp_val = (uint16_t)(dali_value * DALI_PWM_TC_TOP) / 254;
	}
	dali_hal_update_pwm_output(temp_val);
}

/**
 *  \brief ^ꂽDALIlɑΉPWMo͌vZ
 *
 *  \param  dali_value ݒ肷d
 *
 *  \return ΉPWMl
 */
uint16_t dali_cmd_read_pwm_value(uint8_t dali_value)
{
	uint16_t ret;
	uint8_t temp;

	if (dali_variable.var.eeprom_dimming_curve == LOGARITHMIC) {
		/* ޲Ė24ޯĒli[12ޯPWMl̏4ޯ */
		temp = flash_high_pwm_val[dali_value >> 1];
		if ((dali_value & 0x01) == 0x00) {
			/* ް͉4ޯĂɊi[ */
			ret = (temp & 0x0F) << 8;
		} else {
			/* ް͏4ޯĂɊi[ */
			ret = (temp & 0xF0) << 4;
		}

		ret += flash_low_pwm_val[dali_value];
	} else {
		/*  n~4095/254 */
		ret = (uint16_t)(dali_value * DALI_PWM_TC_TOP) / 254;
	}

	return ret;
}

void dali_process_power_on(void)
{
	if (power_on_flag == true) {
		if (power_on_time == 0) {
			power_on_flag = false;
			if (dali_variable.var.eeprom_power_on_level ==
					POWER_MASK) {
				dali.level = dali_variable.var.eeprom_target_level;
			} else {
				if ((dali_variable.var.eeprom_power_on_level <
						dali_variable.var.eeprom_minimum_level) &&
						(dali_variable.var.eeprom_power_on_level !=
						POWER_OFF)) {
					dali.level = dali_variable.var.eeprom_minimum_level;
				} else if (dali_variable.var.eeprom_power_on_level >
						dali_variable.var.eeprom_maximum_level) {
					dali.level = dali_variable.var.eeprom_maximum_level;
				} else {
					dali.level = dali_variable.var.eeprom_power_on_level;
				}
				dali_variable.var.eeprom_target_level =	dali.level;
				eeprom_flag |= PAGE0_UPDATE;
			}

			if (dali.level == POWER_OFF) {
				status_information &= ~LAMP_ARC_POWER_ON;
			} else {
				status_information |= LAMP_ARC_POWER_ON;
			}

			int_dali.level = dali.level;
			fade_direction = FADE_DIRECT;
		}
	}
}

void dali_process_interface_failure(void)
{
	uint8_t temp;
	if (interface_fail_flag) {
		interface_fail_flag = false;
		temp = dali_variable.var.eeprom_system_failure_level;
		if (temp != POWER_MASK) {
			if ((temp < dali_variable.var.eeprom_minimum_level) &&
					(temp != POWER_OFF)) {
				temp = dali_variable.var.eeprom_minimum_level;
			} else if (temp > dali_variable.var.eeprom_maximum_level) {
				temp = dali_variable.var.eeprom_maximum_level;
			}

			dali.level = temp;
			int_dali.level = temp;
			dali_variable.var.eeprom_target_level = dali.level;
			eeprom_flag |= PAGE0_UPDATE;
			fade_direction = FADE_DIRECT;
		}
	}
}

/**
 *  \brief ɂœd͒ω@\
 */
void tc_callback_dali_fading_timer(
		struct tc_module *const module_inst)
{
	uint8_t temp_level, temp0, temp1;
	uint16_t temp_val0, temp_val1;
	uint32_t temp_fade_step;
	uint32_t temp_long_level;

	/* ǏҰgނۑ邽߂ɂłRgp */
	temp_fade_step = int_fade_step;
	temp_level = int_dali.level;
	temp_long_level = int_dali.long_level;
	
	if (power_on_flag == true) {
		if (power_on_time > 0) {
			power_on_time--;
		}
	}

	if (fade_time > 0) {
		fade_time--;
	}

	if (w15min_waiting_time > 0) {
		w15min_waiting_time--;
	}

	if (dapc_sequence == true) {
		if (dapc_sequence_time > 0) {
			dapc_sequence_time--;
		} else {
			dapc_sequence = false;
			dali_variable.var.eeprom_target_level = temp_level;
			eeprom_flag |= PAGE0_UPDATE;
			fade_direction = FADE_STOP;
		}
	}

	if (dali_hal_get_dali_input_level() == 0) {
		if (interface_fail_time == (uint16_t)FAIL_TIME) {
			interface_fail_flag = true;
			interface_fail_time++;
		} else if (interface_fail_time < FAIL_TIME) {
			interface_fail_time++;
		}
	} else {
		interface_fail_time = 0;
	}

	switch (fade_direction) {
	case FADE_IDLE:
		break;

	case FADE_STOP:
		need_fade = false;
		status_information &= ~FADE_RUNNING;
		fade_direction = FADE_IDLE;
		break;

	/* int_fadetimepĒωBڎԂł͂ȂA
	 * ω(inv_int_fadetime_val)ƂĎۂɂ͂𑖍s */
	case FADE_TIME_UP:
		/* ۂߌ덷̌̒ωԂŋ͂ȕωN܂
		 * AڕWق͖̂ł */
		if (temp_level < dali_variable.var.eeprom_target_level) {
			/* ّ */
			if ((0xFE000000 - temp_long_level) <= temp_fade_step) {
				/* ő254 */
				temp_long_level = 0xFE000000;
			} else {
				temp_long_level = temp_long_level + temp_fade_step;
			}
		} else {
			/* IɒωOFF؂ւ */
			fade_direction = FADE_STOP;
		}
		break;

	/* int_fadetimep钀ωB͒~ω܂AƖOFFɂ
	 * BŏlŒ~܂B */
	case FADE_TIME_DOWN:
		if (temp_level > dali_variable.var.eeprom_target_level) {
			/* ٌ */
			if (temp_long_level <= temp_fade_step) {
				temp_long_level = 0;
			} else {
				temp_long_level = temp_long_level - temp_fade_step;
			}
		} else {
			/* IɒωOFF؂ւ */
			fade_direction = FADE_STOP;
		}
		break;

	/* int_fadetimep钀ωB͒~ωAقႭȂꍇ
	 * ɏƖOFFɐ؂ւ܂B */
	case FADE_TIME_DOWN_OFF:
		if (temp_level >= dali_variable.var.eeprom_minimum_level) {
			/* ٌ */
			if (temp_long_level <= temp_fade_step) {
				temp_long_level = 0;
			} else {
				temp_long_level = temp_long_level - temp_fade_step;
			}
		} else {
			/* UŏقɒBƁAƖOFF */
			status_information &= ~LAMP_ARC_POWER_ON;
			temp_long_level = 0;
			fade_direction = FADE_STOP;
		}
		break;

	/* eeprom_fade_rate(flash_fade_rate_val)pĒω */
	case FADE_RATE_UP:
		if (temp_level >= dali_variable.var.eeprom_maximum_level) {
			temp_level = dali_variable.var.eeprom_maximum_level;
			temp_long_level = (uint32_t)temp_level << 24;
			dali_variable.var.eeprom_target_level = temp_level;
			eeprom_flag |= PAGE0_UPDATE;
			status_information |= LIMIT_ERROR;
			/* IɒωOFFɐ؂ւ */
			fade_direction = FADE_STOP;
		} else {
			if (fade_time > 0) {
				/* ㏸ω */
				temp_long_level = temp_long_level + temp_fade_step;	
			} else {
				/* ωI */
				status_information &= ~LIMIT_ERROR;
				dali_variable.var.eeprom_target_level = temp_level;
				eeprom_flag |= PAGE0_UPDATE;
				/* IɒωOFFɐ؂ւ */
				fade_direction = FADE_STOP;
			}
		}
		break;

	/* eeprom_fade_rate(flash_fade_rate_val)p钀ωBƖOFFɐ؂
	 * ȂB */
	case FADE_RATE_DOWN:
		if (temp_level < dali_variable.var.eeprom_minimum_level) {
			temp_level = dali_variable.var.eeprom_minimum_level;
			temp_long_level = (uint32_t)temp_level << 24;
			dali_variable.var.eeprom_target_level = temp_level;
			eeprom_flag |= PAGE0_UPDATE;
			status_information |= LIMIT_ERROR;
			/* IɒωOFFɐ؂ւ */
			fade_direction = FADE_STOP;
		} else {
			if (fade_time > 0) {
				/* ~ω */
				temp_long_level = temp_long_level - temp_fade_step;	
			} else {
				/* ωI */
				status_information &= ~LIMIT_ERROR;
				dali_variable.var.eeprom_target_level = temp_level;
				eeprom_flag |= PAGE0_UPDATE;
				/* IωOFF؂ւ */
				fade_direction = FADE_STOP;
			}
		}
		break;

	/* ڏo */
	case FADE_DIRECT:
		dali_cmd_set_pwm_output(temp_level);
		temp_long_level = (uint32_t)temp_level << 24;
		status_information &= ~FADE_RUNNING;
		fade_direction = FADE_IDLE;
		break;

	default:
		break;
	}

	if (need_fade == true) {
		/* ݂DALI */
		temp0 = temp_long_level >> 24;
		/* DALIBُ̍ŏ8ޯ */
		temp1 = temp_long_level >> 16;
		temp_val0 = dali_cmd_read_pwm_value(temp0);
		/* 2DALIيԂ̒ۊǁB2̒iKԂ̍PWMo͂ōő110łB */
		temp_val1 = ((dali_cmd_read_pwm_value(temp0 + 1) -
				dali_cmd_read_pwm_value(temp0)) * temp1) >> 8;

		dali_hal_update_pwm_output(temp_val0 + temp_val1);
	}
	
	int_dali.long_level = temp_long_level;
}
