/**************************************************************************//**
 * @file		core_cmFunc.h
 * @brief		CMSIS Cortex-Mj֐ ͯ ̧
 * @version		V3.00
 * @date		2012N119
 *
 * @note
 * 쌠 (C) 2009-2012 ARM Limited. s
 *
 * @par
 * ARM Limited (ARM)Cortex-M۾ɊÂϲ ۰ׂŎgp邽߂ɂ̿ĳ
 * Ă܂B̧ق͂̂悤ARMɊÂ۾xJ°ٓ
 * Rɕz邱Ƃł܂B
 *
 * @par
 * ̿ĳ"󂻂̂܂"Œ񋟂܂Bۏ؁AI܂َ͖I܂͖@
 * Iǂ܂݂܂AɐꂸAړÎ߂̎sꐫƓK
 * ÖٓIȕۏ؂͂̿ĳɓKp܂BARM͉ꂩ̔@Ȃ闝RɂĂ
 * ̂悤ȏ󋵂łʓIAtIAhIQ̐ӔC𕉂܂B
 *
 ******************************************************************************/

#ifndef __CORE_CMFUNC_H
#define __CORE_CMFUNC_H


/* ############################### j֐  ############################### */
/** \ingroup  CMSIS_Core_FunctionInterface   
    \defgroup CMSIS_Core_RegAccFunctions CMSISjڼ޽ ֐
  @{
 */

#if   defined ( __CC_ARM ) /*------------------ RealView߲ -----------------*/
/* ARM armccL֐ */

#if (__ARMCC_VERSION < 400677)
  #error "Please use ARM Compiler Toolchain V4.0.677 or later!"
#endif

/* gݍ݊֐ void __enable_irq();  */
/* gݍ݊֐ void __disable_irq(); */

/** \brief ڼ޽擾

    ̊֐͐ڼ޽̓eԂ܂B

    \return ڼ޽l
 */
__STATIC_INLINE uint32_t __get_CONTROL(void)
{
	register uint32_t __regControl         __ASM("control");
	return(__regControl);
}

/** \brief ڼ޽ݒ

    ̊֐͗^ꂽl𐧌ڼ޽ɏ܂B

    \param[in]  control ݒ肷鐧ڼ޽l
 */
__STATIC_INLINE void __set_CONTROL(uint32_t control)
{
	register uint32_t __regControl         __ASM("control");
	__regControl = control;
}

/** \brief IPSRڼ޽擾

    ̊֐IPSRڼ޽̓eԂ܂B

    \return IPSRڼ޽l
 */
__STATIC_INLINE uint32_t __get_IPSR(void)
{
	register uint32_t __regIPSR          __ASM("ipsr");
	return(__regIPSR);
}

/** \brief APSRڼ޽擾

    ̊֐APSRڼ޽̓eԂ܂B

    \return APSRڼ޽l
 */
__STATIC_INLINE uint32_t __get_APSR(void)
{
	register uint32_t __regAPSR          __ASM("apsr");
	return(__regAPSR);
}

/** \brief xPSRڼ޽擾

    ̊֐xPSRڼ޽̓eԂ܂B

    \return xPSRڼ޽l
 */
__STATIC_INLINE uint32_t __get_xPSR(void)
{
	register uint32_t __regXPSR          __ASM("xpsr");
	return(__regXPSR);
}

/** \brief ۾  ߲擾

    ̊֐۾  ߲(PSP)̌ݒlԂ܂B

    \return PSPڼ޽l
 */
__STATIC_INLINE uint32_t __get_PSP(void)
{
	register uint32_t __regProcessStackPointer  __ASM("psp");
	return(__regProcessStackPointer);
}

/** \brief ۾  ߲ݒ

    ̊֐͗^ꂽl۾  ߲(PSP)Ɋ蓖Ă܂B

    \param[in]  topOfProcStack ݒ肷۾  ߲l
 */
__STATIC_INLINE void __set_PSP(uint32_t topOfProcStack)
{
	register uint32_t __regProcessStackPointer  __ASM("psp");
	__regProcessStackPointer = topOfProcStack;
}

/** \brief  ߲擾

    ̊֐͎ ߲(MSP)̌ݒlԂ܂B

    \return MSPڼ޽l
 */
__STATIC_INLINE uint32_t __get_MSP(void)
{
	register uint32_t __regMainStackPointer     __ASM("msp");
	return(__regMainStackPointer);
}

/** \brief  ߲ݒ

    ̊֐͗^ꂽl ߲(MSP)ɂ肠Ă܂B

    \param[in]  topOfMainStack ݒ肷 ߲l
 */
__STATIC_INLINE void __set_MSP(uint32_t topOfMainStack)
{
	register uint32_t __regMainStackPointer     __ASM("msp");
	__regMainStackPointer = topOfMainStack;
}

/** \brief D挠Օ擾

    ̊֐͗D挠Օڼ޽猻݂̗D挠Օ̏ԂԂ܂B

    \return D挠Օl
 */
__STATIC_INLINE uint32_t __get_PRIMASK(void)
{
	register uint32_t __regPriMask         __ASM("primask");
	return(__regPriMask);
}

/** \brief D挠Օݒ

    ̊֐͗^ꂽlD挠Օڼ޽Ɋ蓖Ă܂B

    \param[in]  priMask D挠Օ
 */
__STATIC_INLINE void __set_PRIMASK(uint32_t priMask)
{
	register uint32_t __regPriMask         __ASM("primask");
	__regPriMask = (priMask);
}


#if       (__CORTEX_M >= 0x03)

/** \brief FIQ

    ̊֐CPSRFޯĂ邱ƂɂFIQ荞݂܂B
    łs邱Ƃł܂B
 */
#define __enable_fault_irq                __enable_fiq

/** \brief FIQ֎~

    ̊֐CPSRFޯĂݒ肷邱ƂɂFIQ荞݂֎~܂B
    łs邱Ƃł܂B
 */
#define __disable_fault_irq               __disable_fiq

/** \brief D挠擾

    ̊֐returns the current value of the D挠ڼ޽̌ݒlԂ܂B

    \return D挠ڼ޽l
 */
__STATIC_INLINE uint32_t  __get_BASEPRI(void)
{
	register uint32_t __regBasePri         __ASM("basepri");
	return(__regBasePri);
}

/** \brief D挠ݒ

    ̊֐͗^ꂽlD挠ڼ޽Ɋ蓖Ă܂B

    \param[in]  basePri ݒ肷D挠l
 */
__STATIC_INLINE void __set_BASEPRI(uint32_t basePri)
{
	register uint32_t __regBasePri         __ASM("basepri");
	__regBasePri = (basePri & 0xff);
}

/** \brief QՕ擾

    ̊֐returns the current value of the QՕڼ޽̌ݒlԂ܂B

    \return QՕڼ޽l
 */
__STATIC_INLINE uint32_t __get_FAULTMASK(void)
{
	register uint32_t __regFaultMask       __ASM("faultmask");
	return(__regFaultMask);
}

/** \brief QՕݒ

    ̊֐͗^ꂽlQՕڼ޽Ɋ蓖Ă܂B

    \param[in]  faultMask ݒ肷QՕl
 */
__STATIC_INLINE void __set_FAULTMASK(uint32_t faultMask)
{
	register uint32_t __regFaultMask       __ASM("faultmask");
	__regFaultMask = (faultMask & (uint32_t)1);
}

#endif /* (__CORTEX_M >= 0x03) */

#if       (__CORTEX_M == 0x04)

/** \brief FPSCR擾

    ̊֐͕_/ڼ޽̌ݒlԂ܂B

    \return _/ڼ޽l
 */
__STATIC_INLINE uint32_t __get_FPSCR(void)
{
#if (__FPU_PRESENT == 1) && (__FPU_USED == 1)
	register uint32_t __regfpscr         __ASM("fpscr");
	return(__regfpscr);
#else
	return(0);
#endif
}

/** \brief FPSCRݒ

    ̊֐͗^ꂽl𕂓_/ڼ޽Ɋ蓖Ă܂B

    \param[in]  fpscr ݒ肷镂_/ڼ޽l
 */
__STATIC_INLINE void __set_FPSCR(uint32_t fpscr)
{
#if (__FPU_PRESENT == 1) && (__FPU_USED == 1)
	register uint32_t __regfpscr         __ASM("fpscr");
	__regfpscr = (fpscr);
#endif
}

#endif /* (__CORTEX_M == 0x04) */


#elif defined ( __ICCARM__ ) /*------------------ ICC߲ -------------------*/
/* IAR iccarmL֐ */

#include <cmsis_iar.h>


#elif defined ( __TMS470__ ) /*---------------- TI CCS߲ ------------------*/
/* TI CCSL֐ */

#include <cmsis_ccs.h>


#elif defined ( __GNUC__ ) /*------------------ GNU߲ ---------------------*/
/* GNU gccL֐ */

/** \brief IRQ荞݋

  ̊֐CPSRIޯĂ邱ƂɂIRQ荞݂܂B
  łs邱Ƃł܂B
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE void __enable_irq(void)
{
	__ASM volatile ("cpsie i");
}

/** \brief IRQ荞݋֎~

  ̊֐CPSRIޯĂݒ肷邱ƂɂIRQ荞݂֎~܂B
  łs邱Ƃł܂B
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE void __disable_irq(void)
{
	__ASM volatile ("cpsid i");
}

/** \brief ڼ޽擾

    ̊֐͐ڼ޽̓eԂ܂B

    \return ڼ޽l
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE uint32_t __get_CONTROL(void)
{
	uint32_t result;

	__ASM volatile ("MRS %0, control" : "=r" (result) );
	return(result);
}

/** \brief ڼ޽ݒ

    ̊֐͗^ꂽl𐧌ڼ޽ɏ܂B

    \param[in]  control ݒ肷鐧ڼ޽l
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE void __set_CONTROL(uint32_t control)
{
	__ASM volatile ("MSR control, %0" : : "r" (control) );
}

/** \brief IPSRڼ޽擾

    ̊֐IPSRڼ޽̓eԂ܂B

    \return IPSRڼ޽l
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE uint32_t __get_IPSR(void)
{
	uint32_t result;

	__ASM volatile ("MRS %0, ipsr" : "=r" (result) );
	return(result);
}

/** \brief APSRڼ޽擾

    ̊֐APSRڼ޽̓eԂ܂B

    \return APSRڼ޽l
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE uint32_t __get_APSR(void)
{
	uint32_t result;

	__ASM volatile ("MRS %0, apsr" : "=r" (result) );
	return(result);
}

/** \brief xPSRڼ޽擾

    ̊֐xPSRڼ޽̓eԂ܂B

    \return xPSRڼ޽l
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE uint32_t __get_xPSR(void)
{
	uint32_t result;

	__ASM volatile ("MRS %0, xpsr" : "=r" (result) );
	return(result);
}

/** \brief ۾  ߲擾

    ̊֐returns the current value of the ۾  ߲(PSP)̌ݒlԂ܂B

    \return PSPڼ޽l
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE uint32_t __get_PSP(void)
{
	register uint32_t result;

	__ASM volatile ("MRS %0, psp\n"  : "=r" (result) );
	return(result);
}

/** \brief ۾  ߲ݒ

    ̊֐͗^ꂽl۾  ߲(PSP)Ɋ蓖Ă܂B

    \param[in]  topOfProcStack ݒ肷۾  ߲l
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE void __set_PSP(uint32_t topOfProcStack)
{
	__ASM volatile ("MSR psp, %0\n" : : "r" (topOfProcStack) );
}

/** \brief  ߲擾

    ̊֐͎ ߲(MSP)̌ݒlԂ܂B

    \return MSPڼ޽l
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE uint32_t __get_MSP(void)
{
	register uint32_t result;

	__ASM volatile ("MRS %0, msp\n" : "=r" (result) );
	return(result);
}

/** \brief  ߲ݒ

    ̊֐͗^ꂽl ߲(MSP)Ɋ蓖Ă܂B

    \param[in]  topOfMainStack ݒ肷 ߲l
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE void __set_MSP(uint32_t topOfMainStack)
{
	__ASM volatile ("MSR msp, %0\n" : : "r" (topOfMainStack) );
}

/** \brief D挠Օ擾

    ̊֐͗D挠Օڼ޽猻݂̗D挠Օ̏ԂԂ܂B

    \return D挠Օl
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE uint32_t __get_PRIMASK(void)
{
	uint32_t result;

	__ASM volatile ("MRS %0, primask" : "=r" (result) );
	return(result);
}

/** \brief D挠Օݒ

    ̊֐͗^ꂽlD挠Օڼ޽Ɋ蓖Ă܂B

    \param[in]  priMask D挠Օ
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE void __set_PRIMASK(uint32_t priMask)
{
	__ASM volatile ("MSR primask, %0" : : "r" (priMask) );
}

#if       (__CORTEX_M >= 0x03)

/** \brief FIQ

    ̊֐CPSRFޯĂ邱ƂɂFIQ荞݂܂B
    łs邱Ƃł܂B
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE void __enable_fault_irq(void)
{
	__ASM volatile ("cpsie f");
}

/** \brief FIQ֎~

    ̊֐CPSRFޯĂݒ肷邱ƂɂFIQ荞݂֎~܂B
    łs邱Ƃł܂B
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE void __disable_fault_irq(void)
{
	__ASM volatile ("cpsid f");
}

/** \brief D挠擾

    ̊֐͊D挠ڼ޽̌ݒlԂ܂B

    \return D挠ڼ޽l
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE uint32_t __get_BASEPRI(void)
{
	uint32_t result;

	__ASM volatile ("MRS %0, basepri_max" : "=r" (result) );
	return(result);
}

/** \brief D挠ݒ

    ̊֐͗^ꂽlD挠ڼ޽Ɋ蓖Ă܂B

    \param[in]  basePri ݒ肷D挠l
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE void __set_BASEPRI(uint32_t value)
{
	__ASM volatile ("MSR basepri, %0" : : "r" (value) );
}

/** \brief QՕ擾

    ̊֐͏QՕڼ޽̌ݒlԂ܂B

    \return QՕڼ޽l
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE uint32_t __get_FAULTMASK(void)
{
	uint32_t result;

	__ASM volatile ("MRS %0, faultmask" : "=r" (result) );
	return(result);
}

/** \brief QՕݒ

    ̊֐͗^ꂽlQՕڼ޽Ɋ蓖Ă܂B

    \param[in]  faultMask ݒ肷QՕl
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE void __set_FAULTMASK(uint32_t faultMask)
{
	__ASM volatile ("MSR faultmask, %0" : : "r" (faultMask) );
}

#endif /* (__CORTEX_M >= 0x03) */


#if       (__CORTEX_M == 0x04)

/** \brief FPSCR擾

    ̊֐͕_/ڼ޽̌Ԃ܂B

    \return _/ڼ޽l
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE uint32_t __get_FPSCR(void)
{
#if (__FPU_PRESENT == 1) && (__FPU_USED == 1)
	uint32_t result;

	__ASM volatile ("VMRS %0, fpscr" : "=r" (result) );
	return(result);
#else
   return(0);
#endif
}

/** \brief FPSCRݒ

    ̊֐͗^ꂽl𕂓_/ڼ޽Ɋ蓖Ă܂B

    \param[in]  fpscr ݒ肷镂_/ڼ޽l
 */
__attribute__( ( always_inline ) ) __STATIC_INLINE void __set_FPSCR(uint32_t fpscr)
{
#if (__FPU_PRESENT == 1) && (__FPU_USED == 1)
	__ASM volatile ("VMSR fpscr, %0" : : "r" (fpscr) );
#endif
}

#endif /* (__CORTEX_M == 0x04) */


#elif defined ( __TASKING__ ) /*------------------ TASKING߲ --------------*/
/* TASKING carmL֐ */

/*
 * CMSIS֐ͺׂ߲̑gݍ݊֐ƂĎĂ܂B
 * CMSIŜ̂܂ލXVꂽSĂ̑gݍ݊֐̈ꗗ𓾂ɂ"carm -?i"g
 * pĂB
 */

#endif

/*@} CMSIS_Core_RegAccFunctionsI */

#endif /* __CORE_CMFUNC_H */
