/**
 * \file
 *
 * \brief DALIMޯĂ̕ƕ
 *
 * 쌠 (c) 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include "dali_top.h"

#define BIT_START		0xFF
#define BIT_0			0x01
#define BIT_1			0x02
#define BIT_2			0x03
#define BIT_3			0x04
#define BIT_4			0x05
#define BIT_5			0x06
#define BIT_6			0x07
#define BIT_7			0x08
#define BIT_8			0x09
#define BIT_9			0x0A
#define BIT_10			0x0B
#define BIT_11			0x0C
#define BIT_12			0x0D
#define BIT_13			0x0E
#define BIT_14			0x0F
#define BIT_15			0x10
#define BIT_STOP1		0x11
#define BIT_STOP2		0x12

/* TE_CNT13 */
#define MIN_TE_CNT		(TE_CNT - 5)
#define MAX_TE_CNT		(TE_CNT + 5)
#define MIN_2TE_CNT		(2 * MIN_TE_CNT)
#define MAX_2TE_CNT		(2 * MAX_TE_CNT)
#define STOP_CNT		(4 * TE_CNT)

volatile bool pin_level;

volatile uint8_t level_time;
volatile uint8_t status_receive;
volatile uint8_t dali_rec_addr, dali_rec_data;
volatile uint8_t send_status;
volatile uint8_t dali_send_data;

void configure_extint_channel(void);
void configure_extint_callbacks(void);
void eic_callback_dali_input_detection(void);

/**
 * \brief ODALI݌`Ԑݒ
 *
 */
void configure_extint_channel(void)
{

	struct extint_chan_conf config_extint_chan;

	extint_chan_get_config_defaults(&config_extint_chan);

	config_extint_chan.gpio_pin           = DALI_INPUT_EIC_PIN;
	config_extint_chan.gpio_pin_mux       = DALI_INPUT_EIC_MUX;
	config_extint_chan.detection_criteria = EXTINT_DETECT_BOTH;
	extint_chan_set_config(DALI_INPUT_EIC_LINE, &config_extint_chan);
}

/**
 * \brief DALI݊荞݌`Ԑݒ
 *
 */
void configure_extint_callbacks(void)
{
	extint_register_callback(eic_callback_dali_input_detection,
			DALI_INPUT_EIC_LINE,
			EXTINT_CALLBACK_TYPE_DETECT);

	extint_chan_enable_callback(DALI_INPUT_EIC_LINE,
			EXTINT_CALLBACK_TYPE_DETECT);
}

void dali_bit_init(void)
{
	/* DALIo͌`Ԑݒ */
	struct port_config pin_conf;
	port_get_config_defaults(&pin_conf);

	/* o͂ƂHighق`Ԑݒ */
	pin_conf.direction  = PORT_PIN_DIR_OUTPUT;
	port_pin_set_config(DALI_OUTPUT_PIN, &pin_conf);
	port_pin_set_output_level(DALI_OUTPUT_PIN, HIGH);

	/* DALI͌`Ԑݒ */
	configure_extint_channel();
	configure_extint_callbacks();
}

/**
 * \brief O݊荞ݏ
 *
 * ͊O݊荞ݗpłB
 */
void eic_callback_dali_input_detection(void)
{
	static uint8_t bit_index;
	uint8_t dali_bit_rx;

	pin_level = port_pin_get_input_level(DALI_INPUT_PIN);
	if (status_receive == 0) {
		if (pin_level == LOW) {
			/* DALI޽~[͊JnޯĂ܂B */
			REG_TC3_INTENSET |= 1<<TC_CALLBACK_OVERFLOW;
			bit_index = 0;
			status_receive = BIT_START;
			dali_rec_addr = 0;
			dali_rec_data = 0;
		}
	} else if (status_receive == BIT_START) {
		/* DALI݂2ڂINT0[HighłȂ΂Ȃ܂B */
		if ((level_time > MIN_TE_CNT) && (level_time < MAX_TE_CNT)) {
			/* JnޯĎ擾16ޯ ް */
			status_receive = BIT_0;
			bit_index += 1;
		} else {
			/* JnޯČ */
			status_receive = 0;
		}
	} else if (status_receive < BIT_STOP1) {
		if (level_time > MIN_2TE_CNT) {
			/* (2~Te)o */
			bit_index += 2;
		} else if ((level_time > MIN_TE_CNT) &&
				(level_time < MAX_TE_CNT)) {
			/* Z(1~Te)o */
			bit_index += 1;
		} else {
			status_receive = 0;
		}

		if (bit_index >= 34) {
			/* ŏITeLow(DALIޯ0)ȂA~ޯđOɏ㏸[o */
			status_receive = BIT_STOP1;
		}

		/* ̑2TeޯĂDALIޯĂ𕜍 */
		if (bit_index & 0x01) {
			/* DALIޯĂ𓾂邽߂ɍŉޯĂړfo */
			dali_bit_rx = bit_index >> 1;
			if (dali_bit_rx <= BIT_7) {
				/* ڽ ޲Ď擾 */
				dali_rec_addr <<= 1;
				if (pin_level) {
					dali_rec_addr |= 0x01;
				}
			} else {
				/* ް ޲Ď擾 */
				dali_rec_data <<= 1;
				if (pin_level) {
					dali_rec_data |= 0x01;
					if (dali_bit_rx == BIT_15) {
						/* ŏITeHigh(DALIޯ1)ȂA~ޯĂ̑OTeHigh
						 * Ԃǉ܂B */
						status_receive = BIT_STOP2;
					}
				}
			}
		}
	} else {
		status_receive = 0;
	}
	level_time = 0;
}

void tc_callback_dali_bit_timer(
		struct tc_module *const module_inst)
{
	static uint8_t dali_bit_index;
	static uint8_t bit_length;
	uint8_t dali_bit_tx;
	uint8_t bit_length_temp;

	send_status = dali_get_sent_status_from_stack();
	/* DALI */
	if (status_receive) {
		level_time++;
		if (status_receive == BIT_STOP2) {
			if (pin_level == HIGH) {
				if (level_time > (STOP_CNT + TE_CNT)) {
					/* ~ޯ */
					status_receive = 0;
					/* M */
					dali_set_addr_to_stack(dali_rec_addr);
					dali_set_data_to_stack(dali_rec_data);
					dali_set_received_flag_to_stack(true);
				}
			} else {
				/* DALI݂LowȂ~ޯČ */
				status_receive = 0;
			}
		} else if (status_receive == BIT_STOP1) {
			if (pin_level == HIGH) {
				if (level_time > STOP_CNT) {
					/* ~ޯ */
					status_receive = 0;
					/* M */
					dali_set_addr_to_stack(dali_rec_addr);
					dali_set_data_to_stack(dali_rec_data);
					dali_set_received_flag_to_stack(true);
				}
			} else {
				/* DALI݂LowȂ~ޯČ */
				status_receive = 0;
			}
		} else {
			if (level_time > MAX_2TE_CNT) {
				/* ُ */
				status_receive = 0;
			}
		}
	} else if (send_status) {	/* DALI */
		dali_send_data = dali_get_sent_data_from_stack();
		/* DALItڰёo */
		dali_bit_tx = dali_bit_index;
		bit_length_temp = bit_length;
		bit_length_temp++;
		if (send_status != BIT_STOP1) {
			/* tް ޲ */
			if (dali_bit_tx == 0) {
				/* Jnޯ */
				if (bit_length_temp == 1) {
					port_pin_set_output_level(DALI_OUTPUT_PIN, LOW);
				} else if (bit_length_temp == (TE_CNT + 1)) {
					port_pin_set_output_level(DALI_OUTPUT_PIN, HIGH);
				}
			} else if (dali_send_data & (1 << (BIT_7 - dali_bit_tx))) {
				/* DALIޯĂ1 */
				if (bit_length_temp == 1) {
					port_pin_set_output_level(DALI_OUTPUT_PIN, LOW);
				} else if (bit_length_temp == (TE_CNT + 1)) {
					port_pin_set_output_level(DALI_OUTPUT_PIN, HIGH);
				}
			} else {
				/* DALIޯĂ0 */
				if (bit_length_temp == 1) {
					port_pin_set_output_level(DALI_OUTPUT_PIN, HIGH);
				} else if (bit_length_temp == (TE_CNT + 1)) {
					port_pin_set_output_level(DALI_OUTPUT_PIN, LOW);
				}
			}

			if (bit_length_temp == (2 * TE_CNT)) {
				dali_bit_tx++;
				if (dali_bit_tx > BIT_7) {
					send_status = BIT_STOP1;
					dali_bit_tx = 0;
				}
				bit_length_temp = 0;
			}
		} else {
			/* ~ޯ */
			if (bit_length_temp < (4 * TE_CNT)) {
				port_pin_set_output_level(DALI_OUTPUT_PIN, HIGH);
			} else {
				/* o */
				send_status = SENDING_STOP;
				bit_length_temp = 0;
			}
		}
		dali_set_sent_status_to_stack(send_status);
		bit_length = bit_length_temp;
		dali_bit_index = dali_bit_tx;
	} else {
		/* /Ȃ̏ꍇɂ̌v~ */
		REG_TC3_INTENCLR |= 1<<TC_CALLBACK_OVERFLOW;
	}
}
